.586
.model flat, stdcall  ; 32 bit memory model
option casemap :none  ; case sensitive
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\macros\macros.asm
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
GroupButton	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
InitTree	PROTO :DWORD,:DWORD,:DWORD
GetDirs		PROTO :DWORD,:DWORD
FillTree	PROTO :DWORD
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
S MACRO text
	local lbl
.const
	lbl db text,0
.code
	exitm   <offset lbl>
ENDM
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	ID_TREEVIEW	equ 1002h
	GROUPDIR	equ 1001H
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data?
	hParent           dd ?
	Lev               dd ?
	sw11              dd ?
	hItem             dd ?
	ItemNew           dd ?
	sw13              dd ?
	hSubDir           dd 32   dup(?)
	hDir              dd 32   dup(?)
	PathLen           dd 32   dup(?)
	buffer            db 129  dup(?)
	szLoadPath        db 256  dup(?)
	szBuffZ           db 256  dup(?)
	FindData          WIN32_FIND_DATA <?>
	lvi               LV_ITEM         <?>                  
	ofn               OPENFILENAME    <?>
	tvis              TV_INSERTSTRUCT <?>
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data
	szDisplayName     db "TestTree",0
	TreeViewClass     db "SysTreeView32",0
	ButtonClassName   db "button",0
	szDir             db  'L:\*.*',0
	szDir1            db  " :\",0
	szBackS           db  '\',0
	szEnd             db  '*.*',0
	CourierTxt        db  "MS Sans Serif",0
	Parent		  db  "C:",0
	
	CommandLine       dd 0
	hWnd              dd 0
	hIcon             dd 0
	hInstance         dd 0
	hFont             dd 0
	hWndTree          dd 0
	hImageList        dd 0
	hBitmap           dd 0
	hNumCB            dd 0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.code
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start:
	invoke GetModuleHandle, NULL
	mov    hInstance, eax

	invoke GetCommandLine
	mov    CommandLine, eax

	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
TreeNotify proc uses ebx lParam:DWORD
	LOCAL tvi:TV_ITEM
	LOCAL Sedi:DWORD
	LOCAL szWork1[64]:BYTE, szWork2[64]:BYTE, szBuff0[256]:BYTE, szBuff1[256]:BYTE
        
        mov     eax, lParam
        mov     ebx, (NM_TREEVIEW ptr [eax]).hdr.code
        mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
        mov     edx, (NM_TREEVIEW ptr [eax]).itemNew.state
        .if ebx == TVN_ITEMEXPANDING || ebx == TVN_SELCHANGINGA
		.if ebx == TVN_SELCHANGINGA
			.if ecx == hParent
				.if sw13 == 13
					and     sw13, 0
					mov     eax, 1
					ret
				.endif
			.endif
			test   (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
			jz     Ret0
		.endif

		and     sw11, 0
		.if edx && edx != 2 || ebx == TVN_SELCHANGINGA
			mov     sw11, 14
		.endif

		mov     hItem, ecx
		mov     ItemNew, ecx
		mov     tvi.hItem, ecx
		mov     tvi.imask, TVIF_TEXT
		lea     eax, szWork1
		mov     tvi.pszText, eax
		mov     tvi.cchTextMax, 64
		push    edx
		invoke  SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
		pop     edx
		mov     eax, hItem
		.if !edx && eax == hParent
			mov     sw13, 13
			jmp     Ret0
		.endif
         
		lea     edi, szBuff1
		add     edi, 250
		mov     byte ptr[edi], 0
		mov     byte ptr[edi-1], '\'
		sub     edi, 2
		mov     Sedi, edi
		.while (eax != hParent)
			invoke  lstrlen, addr szWork1
			mov     ebx, eax
			mov     ecx, eax
			mov     edi, Sedi
			.while (ecx)
				mov     al, byte ptr szWork1[ebx-1]
				mov     byte ptr[edi], al
				dec     edi
				dec     ebx
				dec     ecx
			.endw
			mov     byte ptr[edi], '\'
			dec     edi
			mov     Sedi, edi
			invoke  SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_PARENT, hItem
			mov     hItem, eax
			mov     tvi.hItem, eax
			mov     tvi.imask, TVIF_TEXT
			lea     eax, szWork1
			mov     tvi.pszText, eax
			mov     tvi.cchTextMax, 64
			invoke  SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
			mov     eax, hItem
		.endw
		mov     edi, Sedi
		mov     byte ptr[edi], ':'
		mov     al, byte ptr szDir
		mov     byte ptr[edi-1], al
		sub     edi, 2
		lea     eax, szBuff1
		sub     edi, eax
		inc     edi
		invoke  lstrcpy, addr szBuff0, addr szBuff1[edi]
		invoke  lstrcpy, addr szLoadPath, addr szBuff0
		invoke  lstrcat, addr szBuff0, addr szEnd
		.if sw11 != 14
			invoke   GetDirs, 1, addr szBuff0
		.endif
		invoke  SendMessage, hWndTree, TVM_SORTCHILDREN, 0, ItemNew
		invoke  SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, ItemNew

         .elseif ebx == TVN_SELCHANGEDA
		test   (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
                jz     Ret0
		mov    tvi.hItem, ecx
		mov    tvi.imask, TVIF_TEXT
		lea    eax, szWork1
		mov    tvi.pszText, eax
		mov    tvi.cchTextMax, 64
		invoke SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
		mov    byte ptr szBuff0, 0
		invoke lstrlen, addr szWork1
		.if eax > 2 || byte ptr szWork1 != ':'                      ; Not root dir
			invoke lstrcpy, addr szBuff0, addr szLoadPath
		.else
			invoke lstrcat, addr szBuff0, addr szWork1
		.endif
		invoke  SendMessage, hWnd, WM_SETTEXT, 0, addr szBuff0
        .endif
	invoke LockWindowUpdate, 0          ; Lock parent to avoid flicker
Ret0:
        xor    eax, eax   
        ret
TreeNotify endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
	LOCAL wc   :WNDCLASSEX
	LOCAL msg  :MSG

	mov wc.cbSize,         sizeof WNDCLASSEX
	mov wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov wc.lpfnWndProc,    offset WndProc
	mov wc.cbClsExtra,     NULL
	mov wc.cbWndExtra,     NULL
	m2m wc.hInstance,      hInst
	mov wc.hbrBackground,  COLOR_BTNFACE+1
	mov wc.lpszMenuName,   NULL
	mov wc.lpszClassName,  S('TreeViewWinClass')
	m2m wc.hIcon,          hIcon
	invoke LoadCursor,NULL,IDC_ARROW
	mov wc.hCursor,        eax
	m2m wc.hIconSm,        hIcon

	invoke RegisterClassEx, ADDR wc

	invoke CreateWindowEx,WS_EX_LEFT,S('TreeViewWinClass'),ADDR szDisplayName,WS_OVERLAPPED or WS_SYSMENU,
                   200,200,250,280,NULL,NULL,hInst,NULL
	mov   hWnd,eax

	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd

	.WHILE TRUE                                        
                invoke GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam                           
	ret

WinMain endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam :DWORD
	LOCAL Ps     :PAINTSTRUCT
	LOCAL hBrush :HBRUSH
	LOCAL hhDC   :HDC
	LOCAL CntZ   :DWORD
	LOCAL tvi    :TV_ITEM
	LOCAL rct    :RECT

        .if uMsg == WM_CREATE
                invoke CreateFont,14,6,0,0,550,FALSE,FALSE,FALSE,0,0,0,0,0,offset CourierTxt
                mov hFont,eax

		;invoke GroupButton,hWin,S('Dir'),15,5,211,155,GROUPDIR

		invoke CreateWindowEx, WS_EX_STATICEDGE, addr TreeViewClass, 0,\
			WS_CHILD+WS_VISIBLE+TVS_HASLINES+TVS_HASBUTTONS+TVS_LINESATROOT+WS_CLIPSIBLINGS+CS_OWNDC ,\
			20, 20, 200, 200, hWin, ID_TREEVIEW, hInstance, 0
		mov     hWndTree, eax					;tree

		invoke SendMessage,hWndTree,TVM_SETBKCOLOR,0,0cfffffH  
		invoke SendMessage,hWndTree,WM_SETFONT,hFont,TRUE
		invoke SendMessage,hWndTree,TVM_SETTEXTCOLOR,0,0H

		invoke ImageList_Create, 16, 16, ILC_COLOR16, 10, 10
		mov    hImageList, eax

		invoke LoadBitmap, hInstance, 4006
		mov    hBitmap,eax

		invoke ImageList_Add, hImageList, hBitmap, NULL
		invoke DeleteObject, hBitmap
		invoke SendMessage, hWndTree, TVM_SETIMAGELIST,0, hImageList


		invoke GetCurrentDirectory,128,addr buffer
		lea esi,buffer
		lea edi,szDir1
		lodsb
		stosb           ;szDir1 

		invoke GetDriveType,addr szDir1
		sub eax,eax
		mov al,byte ptr [szDir1]
		mov Parent,al
		mov szDir,al

		invoke lstrcpy, addr szBuffZ, addr szDir
		invoke InitTree, 2, addr szBuffZ,hNumCB

  	.elseif uMsg==WM_NOTIFY
		.if wParam == ID_TREEVIEW
			invoke TreeNotify, lParam
		.endif
	.elseif uMsg == WM_DESTROY
                invoke PostQuitMessage,NULL
                return 0 
	.endif
    
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

WndProc endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GroupButton proc hParent0:DWORD, lpText:DWORD,a0:DWORD,b0:DWORD,wd0:DWORD,ht0:DWORD,ID0:DWORD

	invoke CreateWindowEx,0,S('BUTTON'),lpText,050000007H,
			a0,b0,wd0,ht0,hParent0,ID0,
			hInstance,NULL
	ret

GroupButton endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
InitTree proc pCode:DWORD, Input,NumBit

	invoke LockWindowUpdate, hWndTree          ; Lock parent to avoid flicker
	invoke SendMessage, hWndTree, TVM_DELETEITEM, 0, TVI_ROOT
        mov    tvis.hParent, NULL
        mov    tvis.hInsertAfter, TVI_ROOT
        mov    tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
        mov    tvis.item.pszText, offset Parent
        .if NumBit == 0
		mov     tvis.item.iImage, 0
		mov     tvis.item.iSelectedImage, 0
        .elseif NumBit == 1
		mov     tvis.item.iImage, 1
		mov     tvis.item.iSelectedImage, 1
        .else
		mov     tvis.item.iImage, 2
		mov     tvis.item.iSelectedImage, 2
        .endif
	invoke  SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
        mov     ecx, Lev
        mov     hDir[ecx*4], eax
        mov     hParent, eax

	invoke  GetDirs, pCode, Input
	invoke  SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hParent
	invoke  SendMessage, hWndTree, TVM_SORTCHILDREN, 0, hParent
	invoke  SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, NULL ;hParent
	invoke  LockWindowUpdate, 0
	invoke  SetFocus, hWndTree
        ret

InitTree endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GetDirs PROC pCode:DWORD, Input
	LOCAL tvi:TV_ITEM
	LOCAL Dirs:DWORD, Cnt, hFind
	LOCAL szBuff0[256]:BYTE, szBuff1[256]:BYTE

        and sw11, 0
	.if pCode == 1
		mov sw11, 1
	.endif

	invoke lstrcpy, addr szBuff0, Input
	invoke FindFirstFile, addr szBuff0, addr FindData
        test   eax, eax
        js     NoFile
        mov    hFind, eax

	jmp    ChkDir
NextDir:
	invoke FindNextFile, hFind, addr FindData
        test   eax, eax
        jz     NoFile				;GetDir
ChkDir:
	.if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		.if byte ptr FindData.cFileName == '.' || dword ptr FindData.cFileName == 'YCER' 
			jmp     NextDir
		.endif
		.if pCode == 1
			invoke  lstrlen, addr szBuff0
			sub     eax, 3
			invoke  lstrcpyn, addr szBuff1, addr szBuff0, eax
			invoke  lstrcat, addr szBuff1, addr szBackS
		.else
			invoke  lstrcpyn, addr szBuff1, addr szDir, 4
		.endif
		invoke  lstrcat, addr szBuff1, addr FindData.cFileName
		invoke  lstrcat, addr szBuff1, addr szDir+2
		mov     Lev, 0
		invoke  FillTree, addr FindData.cFileName
		jmp     GetSubDir
	.endif
        jmp     NextDir
GetSubDir:
	invoke  FindFirstFile, addr szBuff1, addr FindData
	.if eax == -1
		mov     Lev, 0
		jmp     NextDir
	.endif
        mov     ecx, Lev
        mov     hSubDir[ecx*4], eax
        jmp     ChkSubDir
NextSubDir:
        mov     ecx, Lev
	invoke  FindNextFile, hSubDir[ecx*4], addr FindData
	.if !eax                       ; eax = 0 = failure
		mov     ecx, Lev   
		invoke  FindClose, hSubDir[ecx*4]
		mov     Lev, 0
		jmp     NextDir
	.endif
ChkSubDir:
	.if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		.if byte ptr FindData.cFileName == '.'
			jmp     NextSubDir
		.endif
		invoke  lstrlen, addr szBuff1
		mov     ecx, Lev
		mov     PathLen[ecx*4], eax
		sub     eax, 2
		invoke  lstrcpyn, addr szBuff1, addr szBuff1, eax
		invoke  lstrcat, addr szBuff1, addr FindData.cFileName
		invoke  lstrcat, addr szBuff1, addr szDir+2
		inc     Lev
		.if Lev < 2
			mov     eax, hItem
			mov     tvi.hItem, eax
			mov     tvi.imask, TVIF_CHILDREN
			mov     tvi.cChildren, 1
			invoke  SendMessage, hWndTree, TVM_SETITEM, 0, addr tvi
		.endif
		jmp     GetSubDir
	.endif
        jmp     NextSubDir
NoFile:
	invoke  FindClose, hFind
        xor     eax, eax
        ret

GetDirs endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
FillTree proc uses ebx DirName:DWORD

        mov     ebx, Lev   
        mov     eax, hDir[ebx*4]
	.if Lev == 0 && !sw11
		mov     eax, hParent
	.elseif Lev == 0 && sw11
		mov     eax, ItemNew
	.endif
        mov     tvis.hParent, eax
        mov     tvis.hInsertAfter, TVI_LAST
        mov     eax, DirName
        mov     tvis.item.pszText, eax
        mov     tvis.item.iImage, 3
        mov     tvis.item.iSelectedImage,4
	invoke  SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
        mov     hItem, eax
        mov     ebx, Lev
        inc     ebx
        mov     hDir[ebx*4], eax

        xor     eax, eax
        ret

FillTree endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

end start